base-files: add sysupgrade -u to skip unchanged files
[openwrt/openwrt.git] / package / base-files / files / sbin / sysupgrade
index a378b029500ac5981d504889b0b3e6af3cf92a0d..d4bb7a164fe3b139e8a6481011990cab1ffbc40a 100755 (executable)
@@ -10,6 +10,7 @@ export VERBOSE=1
 export SAVE_CONFIG=1
 export SAVE_OVERLAY=0
 export SAVE_PARTITIONS=1
+export SKIP_UNCHANGED=0
 export CONF_IMAGE=
 export CONF_BACKUP_LIST=0
 export CONF_BACKUP=
@@ -28,15 +29,16 @@ while [ -n "$1" ]; do
                -n) export SAVE_CONFIG=0;;
                -c) export SAVE_OVERLAY=1;;
                -p) export SAVE_PARTITIONS=0;;
+               -u) export SKIP_UNCHANGED=1;;
                -b|--create-backup) export CONF_BACKUP="$2" NEED_IMAGE=1; shift;;
                -r|--restore-backup) export CONF_RESTORE="$2" NEED_IMAGE=1; shift;;
-               -l|--list-backup) export CONF_BACKUP_LIST=1; break;;
+               -l|--list-backup) export CONF_BACKUP_LIST=1;;
                -f) export CONF_IMAGE="$2"; shift;;
                -F|--force) export FORCE=1;;
                -T|--test) export TEST=1;;
                -h|--help) export HELP=1; break;;
                -*)
-                       echo "Invalid option: $1"
+                       echo "Invalid option: $1" >&2
                        exit 1
                ;;
                *) break;;
@@ -49,15 +51,16 @@ export CONF_TAR=/tmp/sysupgrade.tgz
 
 IMAGE="$1"
 
-[ -z "$IMAGE" -a -z "$NEED_IMAGE" -o $HELP -gt 0 ] && {
+[ -z "$IMAGE" -a -z "$NEED_IMAGE" -a $CONF_BACKUP_LIST -eq 0 -o $HELP -gt 0 ] && {
        cat <<EOF
 Usage: $0 [<upgrade-option>...] <image file or URL>
-       $0 [-q] [-i] <backup-command> <file>
+       $0 [-q] [-i] [-c] [-u] <backup-command> <file>
 
 upgrade-option:
        -f <config>  restore configuration from .tar.gz (file or url)
        -i           interactive mode
        -c           attempt to preserve all changed files in /etc/
+       -u           skip from backup files that are equal to those in /rom
        -n           do not save configuration over reflash
        -p           do not attempt to restore the partition table after flash.
        -T | --test
@@ -115,46 +118,55 @@ list_changed_conffiles() {
        done
 }
 
-add_uci_conffiles() {
+add_conffiles() {
        local file="$1"
        ( find $(sed -ne '/^[[:space:]]*$/d; /^#/d; p' \
                /etc/sysupgrade.conf /lib/upgrade/keep.d/* 2>/dev/null) \
-               -type f -o -type l 2>/dev/null;
+               \( -type f -o -type l \) $find_filter 2>/dev/null;
          list_changed_conffiles ) | sort -u > "$file"
        return 0
 }
 
 add_overlayfiles() {
        local file="$1"
-       find /overlay/upper/etc/ -type f -o -type l | sed \
-               -e 's,^/overlay\/upper/,/,' \
-               -e '\,/META_[a-zA-Z0-9]*$,d' \
-               -e '\,/functions.sh$,d' \
+       ( cd /overlay/upper/; find ./etc \( -type f -o -type l \) $find_filter | sed \
+               -e 's,^\.,,' \
+               -e '\,^/etc/board.json$,d' \
                -e '\,/[^/]*-opkg$,d' \
-       > "$file"
+               -e '\,^/etc/urandom.seed$,d' \
+       )> "$file"
        return 0
 }
 
 # hooks
-sysupgrade_image_check="fwtool_check_image platform_check_image"
+sysupgrade_image_check="fwtool_check_signature fwtool_check_image platform_check_image"
 
 if [ $SAVE_OVERLAY = 1 ]; then
        [ ! -d /overlay/upper/etc ] && {
-               echo "Cannot find '/overlay/upper/etc', required for '-c'"
+               echo "Cannot find '/overlay/upper/etc', required for '-c'" >&2
                exit 1
        }
        sysupgrade_init_conffiles="add_overlayfiles"
 else
-       sysupgrade_init_conffiles="add_uci_conffiles"
+       sysupgrade_init_conffiles="add_conffiles"
+fi
+
+find_filter=""
+if [ $SKIP_UNCHANGED = 1 ]; then
+       [ ! -d /rom/ ] && {
+               echo "'/rom/' is required by '-u'"
+               exit 1
+       }
+       find_filter='( ( -exec test -e /rom/{} ; -exec cmp -s /{} /rom/{} ; ) -o -print )'
 fi
 
 include /lib/upgrade
 
 do_save_conffiles() {
-       local conf_tar="${1:-$CONF_TAR}"
+       local conf_tar="$1"
 
        [ -z "$(rootfs_type)" ] && {
-               echo "Cannot save config while running from ramdisk."
+               echo "Cannot save config while running from ramdisk." >&2
                ask_bool 0 "Abort" && exit
                rm -f "$conf_tar"
                return 0
@@ -165,6 +177,11 @@ do_save_conffiles() {
        v "Saving config files..."
        [ "$VERBOSE" -gt 1 ] && TAR_V="v" || TAR_V=""
        tar c${TAR_V}zf "$conf_tar" -T "$CONFFILES" 2>/dev/null
+       if [ "$?" -ne 0 ]; then
+               echo "Failed to create the configuration backup."
+               rm -f "$conf_tar"
+               exit 1
+       fi
 
        rm -f "$CONFFILES"
 }
@@ -183,7 +200,7 @@ fi
 
 if [ -n "$CONF_RESTORE" ]; then
        if [ "$CONF_RESTORE" != "-" ] && [ ! -f "$CONF_RESTORE" ]; then
-               echo "Backup archive '$CONF_RESTORE' not found."
+               echo "Backup archive '$CONF_RESTORE' not found." >&2
                exit 1
        fi
 
@@ -193,12 +210,13 @@ if [ -n "$CONF_RESTORE" ]; then
 fi
 
 type platform_check_image >/dev/null 2>/dev/null || {
-       echo "Firmware upgrade is not implemented for this platform."
+       echo "Firmware upgrade is not implemented for this platform." >&2
        exit 1
 }
 
 case "$IMAGE" in
-       http://*)
+       http://*|\
+       https://*)
                wget -O/tmp/sysupgrade.img "$IMAGE"
                IMAGE=/tmp/sysupgrade.img
                ;;
@@ -208,7 +226,7 @@ IMAGE="$(readlink -f "$IMAGE")"
 
 case "$IMAGE" in
        '')
-               echo "Image file not found."
+               echo "Image file not found." >&2
                exit 1
                ;;
        /tmp/*) ;;
@@ -225,10 +243,10 @@ export ARGC=1
 for check in $sysupgrade_image_check; do
        ( $check "$IMAGE" ) || {
                if [ $FORCE -eq 1 ]; then
-                       echo "Image check '$check' failed but --force given - will update anyway!"
+                       echo "Image check '$check' failed but --force given - will update anyway!" >&2
                        break
                else
-                       echo "Image check '$check' failed."
+                       echo "Image check '$check' failed." >&2
                        exit 1
                fi
        }
@@ -239,14 +257,14 @@ if [ -n "$CONF_IMAGE" ]; then
                # .gz files
                1f8b) ;;
                *)
-                       echo "Invalid config file. Please use only .tar.gz files"
+                       echo "Invalid config file. Please use only .tar.gz files" >&2
                        exit 1
                ;;
        esac
        get_image "$CONF_IMAGE" "cat" > "$CONF_TAR"
        export SAVE_CONFIG=1
 elif ask_bool $SAVE_CONFIG "Keep config files over reflash"; then
-       [ $TEST -eq 1 ] || do_save_conffiles
+       [ $TEST -eq 1 ] || do_save_conffiles "$CONF_TAR"
        export SAVE_CONFIG=1
 else
        [ $TEST -eq 1 ] || rm -f "$CONF_TAR"